%analisi 4 condizioni stimolazione/levodopa singolo nucleo

cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
    
%apertura file
[file1,pathFile]=uigetfile('*.txt','FILE .TXT OFFOFF');
cd(pathFile);
[file2,pathFile]=uigetfile('*.txt','FILE .TXT OFFON');
cd(pathFile);
[file3,pathFile]=uigetfile('*.txt','FILE .TXT ONON');
cd(pathFile);
[file4,pathFile]=uigetfile('*.txt','FILE .TXT ONOFF');
cd(pathFile);

%Informazioni file
paz=input('Nome paziente: ');
lato=input('Lato stimolato:');
controlat=input('Controalterale: ');

%Caricamento dati
canale='%*f%*f%f%f';
[clat1,stim1]=textread(file1,canale,'headerlines',1,'delimiter','\t');
[clat2,stim2]=textread(file2,canale,'headerlines',1,'delimiter','\t');
[clat3,stim3]=textread(file3,canale,'headerlines',1,'delimiter','\t');
[clat4,stim4]=textread(file4,canale,'headerlines',1,'delimiter','\t');

%----------------------CONDIZIONE OFF OFF--------------------------------
%Normalizzazione con passa alto
Bn=fir1(300,600/1250,'high');
An=1;
StimTemp=filter(Bn,An,stim1);
StimFilt=(stim1-mean(StimTemp))./std(StimTemp);
ClatTemp=filter(Bn,An,clat1);
ClatFilt=(clat1-mean(ClatTemp))./std(ClatTemp);


%Filtraggio e sottocampionamento (campionare 125 e nfft 128)
fs=125;
load('LP45Hz_2500.mat');
A=filt1.tf.den;
C=filt1.tf.num;
stim2500=filtfilt(C,A,StimFilt);
clat2500=filtfilt(C,A,ClatFilt);
ystim=stim2500([1:2500/fs:length(stim2500)]);
yclat=clat2500([1:2500/fs:length(clat2500)]);

%Calcolo e visualizzazione spettro
nfft=128;
[Pstim,f] = pwelch(ystim,hanning(nfft),0,nfft,fs);
PSD_OFFOFF=abs(Pstim);
[Pclat,f] = pwelch(yclat,hanning(nfft),0,nfft,fs);
PSD_OFFOFF2=abs(Pclat);

%Salvataggio spettri
cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
cd('Stim')
save PSD_OFFOFF Pstim
cd ..
cd ('Clat')
save PSD_OFFOFF_Clat Pclat



%Integrali/medie bande nelle 4 condizioni (da articolo modificazioni
%filter)
flowfreq=[1 7];
fbeta=[8 20];
fhighbeta=[21 40];
falpha=[8 12];
flowbeta=[13 20];

%Low Frequencies
lfMin=find(f>=flowfreq(1)&f<=flowfreq(2));
lfPwr=sum(Pstim(lfMin));
lfPwrMedio=lfPwr/length(lfMin);
lfPwr2=sum(Pclat(lfMin));
lfPwrMedio2=lfPwr2/length(lfMin);

%Beta
betaMin=find(f>=fbeta(1)&f<=fbeta(2));
betaPwr=sum(Pstim(betaMin));
betaPwrMedio=betaPwr/length(betaMin);
betaPwr2=sum(Pclat(betaMin));
betaPwrMedio2=betaPwr2/length(betaMin);

%High-Beta
highbetaMin=find(f>=fhighbeta(1)&f<=fhighbeta(2));
hbPwr=sum(Pstim(highbetaMin));
hbPwrMedio=hbPwr/length(highbetaMin);
hbPwr2=sum(Pclat(highbetaMin));
hbPwrMedio2=hbPwr2/length(highbetaMin);

%Alpha
alphaMin=find(f>=falpha(1)&f<=falpha(2));
aPwr=sum(Pstim(alphaMin));
aPwrMedio=aPwr/length(alphaMin);
aPwr2=sum(Pclat(alphaMin));
aPwrMedio2=aPwr2/length(alphaMin);

%Low-Beta
lowbetaMin=find(f>=flowbeta(1)&f<=flowbeta(2));
lbPwr=sum(Pstim(lowbetaMin));
lbPwrMedio=lbPwr/length(lowbetaMin);
lbPwr2=sum(Pclat(lowbetaMin));
lbPwrMedio2=lbPwr2/length(lowbetaMin);

%Vettori potenze OFFOFF
IntStimOFFOFF=[lfPwr;betaPwr;hbPwr;aPwr;lbPwr]';
MediaStimOFFOFF=[lfPwrMedio;betaPwrMedio;hbPwrMedio;aPwrMedio;lbPwrMedio]';

IntClatOFFOFF=[lfPwr2;betaPwr2;hbPwr2;aPwr2;lbPwr2]';
MediaClatOFFOFF=[lfPwrMedio2;betaPwrMedio2;hbPwrMedio2;aPwrMedio2;lbPwrMedio2]';

clear StimTemp
clear StimFilt
clear ClatTemp
clear ClatFilt
clear stim2500
clear clat2500
clear ystim
clear yclat
cd ..
cd ..

%----------------------CONDIZIONE OFF ON--------------------------------
%Normalizzazione con passa alto
Bn=fir1(300,600/1250,'high');
An=1;
StimTemp=filter(Bn,An,stim2);
StimFilt=(stim2-mean(StimTemp))./std(StimTemp);
ClatTemp=filter(Bn,An,clat2);
ClatFilt=(clat2-mean(ClatTemp))./std(ClatTemp);


%Filtraggio e sottocampionamento (campionare 125 e nfft 128)
fs=125;
load('LP45Hz_2500.mat');
A=filt1.tf.den;
C=filt1.tf.num;
stim2500=filtfilt(C,A,StimFilt);
clat2500=filtfilt(C,A,ClatFilt);
ystim=stim2500([1:2500/fs:length(stim2500)]);
yclat=clat2500([1:2500/fs:length(clat2500)]);

%Calcolo e visualizzazione spettro
nfft=128;
[Pstim,f] = pwelch(ystim,hanning(nfft),0,nfft,fs);
PSD_OFFON=abs(Pstim);
[Pclat,f] = pwelch(yclat,hanning(nfft),0,nfft,fs);
PSD_OFFON2=abs(Pclat);

%Salvataggio spettri
cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
cd('Stim')
save PSD_OFFON Pstim
cd ..
cd ('Clat')
save PSD_OFFON_Clat Pclat


%Integrali/medie bande nelle 4 condizioni (da articolo modificazioni
%filter)
flowfreq=[1 7];
fbeta=[8 20];
fhighbeta=[21 40];
falpha=[8 12];
flowbeta=[13 20];

%Low Frequencies
lfMin=find(f>=flowfreq(1)&f<=flowfreq(2));
lfPwr=sum(Pstim(lfMin));
lfPwrMedio=lfPwr/length(lfMin);
lfPwr2=sum(Pclat(lfMin));
lfPwrMedio2=lfPwr2/length(lfMin);

%Beta
betaMin=find(f>=fbeta(1)&f<=fbeta(2));
betaPwr=sum(Pstim(betaMin));
betaPwrMedio=betaPwr/length(betaMin);
betaPwr2=sum(Pclat(betaMin));
betaPwrMedio2=betaPwr2/length(betaMin);

%High-Beta
highbetaMin=find(f>=fhighbeta(1)&f<=fhighbeta(2));
hbPwr=sum(Pstim(highbetaMin));
hbPwrMedio=hbPwr/length(highbetaMin);
hbPwr2=sum(Pclat(highbetaMin));
hbPwrMedio2=hbPwr2/length(highbetaMin);

%Alpha
alphaMin=find(f>=falpha(1)&f<=falpha(2));
aPwr=sum(Pstim(alphaMin));
aPwrMedio=aPwr/length(alphaMin);
aPwr2=sum(Pclat(alphaMin));
aPwrMedio2=aPwr2/length(alphaMin);

%Low-Beta
lowbetaMin=find(f>=flowbeta(1)&f<=flowbeta(2));
lbPwr=sum(Pstim(lowbetaMin));
lbPwrMedio=lbPwr/length(lowbetaMin);
lbPwr2=sum(Pclat(lowbetaMin));
lbPwrMedio2=lbPwr2/length(lowbetaMin);

%Vettori potenze OFFON
IntStimOFFON=[lfPwr;betaPwr;hbPwr;aPwr;lbPwr]';
MediaStimOFFON=[lfPwrMedio;betaPwrMedio;hbPwrMedio;aPwrMedio;lbPwrMedio]';

IntClatOFFON=[lfPwr2;betaPwr2;hbPwr2;aPwr2;lbPwr2]';
MediaClatOFFON=[lfPwrMedio2;betaPwrMedio2;hbPwrMedio2;aPwrMedio2;lbPwrMedio2]';

clear StimTemp
clear StimFilt
clear ClatTemp
clear ClatFilt
clear stim2500
clear clat2500
clear ystim
clear yclat
cd ..
cd ..

%----------------------CONDIZIONE ON ON--------------------------------
%Normalizzazione con passa alto
Bn=fir1(300,600/1250,'high');
An=1;
StimTemp=filter(Bn,An,stim3);
StimFilt=(stim3-mean(StimTemp))./std(StimTemp);
ClatTemp=filter(Bn,An,clat3);
ClatFilt=(clat3-mean(ClatTemp))./std(ClatTemp);


%Filtraggio e sottocampionamento (campionare 125 e nfft 128)
fs=125;
load('LP45Hz_2500.mat');
A=filt1.tf.den;
C=filt1.tf.num;
stim2500=filtfilt(C,A,StimFilt);
clat2500=filtfilt(C,A,ClatFilt);
ystim=stim2500([1:2500/fs:length(stim2500)]);
yclat=clat2500([1:2500/fs:length(clat2500)]);

%Calcolo e visualizzazione spettro
nfft=128;
[Pstim,f] = pwelch(ystim,hanning(nfft),0,nfft,fs);
PSD_ONON=abs(Pstim);
[Pclat,f] = pwelch(yclat,hanning(nfft),0,nfft,fs);
PSD_ONON2=abs(Pclat);

%Salvataggio spettri
cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
cd('Stim')
save PSD_ONON Pstim
cd ..
cd ('Clat')
save PSD_ONON_Clat Pclat


%Integrali/medie bande nelle 4 condizioni (da articolo modificazioni
%filter)
flowfreq=[1 7];
fbeta=[8 20];
fhighbeta=[21 40];
falpha=[8 12];
flowbeta=[13 20];

%Low Frequencies
lfMin=find(f>=flowfreq(1)&f<=flowfreq(2));
lfPwr=sum(Pstim(lfMin));
lfPwrMedio=lfPwr/length(lfMin);
lfPwr2=sum(Pclat(lfMin));
lfPwrMedio2=lfPwr2/length(lfMin);

%Beta
betaMin=find(f>=fbeta(1)&f<=fbeta(2));
betaPwr=sum(Pstim(betaMin));
betaPwrMedio=betaPwr/length(betaMin);
betaPwr2=sum(Pclat(betaMin));
betaPwrMedio2=betaPwr2/length(betaMin);

%High-Beta
highbetaMin=find(f>=fhighbeta(1)&f<=fhighbeta(2));
hbPwr=sum(Pstim(highbetaMin));
hbPwrMedio=hbPwr/length(highbetaMin);
hbPwr2=sum(Pclat(highbetaMin));
hbPwrMedio2=hbPwr2/length(highbetaMin);

%Alpha
alphaMin=find(f>=falpha(1)&f<=falpha(2));
aPwr=sum(Pstim(alphaMin));
aPwrMedio=aPwr/length(alphaMin);
aPwr2=sum(Pclat(alphaMin));
aPwrMedio2=aPwr2/length(alphaMin);

%Low-Beta
lowbetaMin=find(f>=flowbeta(1)&f<=flowbeta(2));
lbPwr=sum(Pstim(lowbetaMin));
lbPwrMedio=lbPwr/length(lowbetaMin);
lbPwr2=sum(Pclat(lowbetaMin));
lbPwrMedio2=lbPwr2/length(lowbetaMin);

%Vettori potenze ONON
IntStimONON=[lfPwr;betaPwr;hbPwr;aPwr;lbPwr]';
MediaStimONON=[lfPwrMedio;betaPwrMedio;hbPwrMedio;aPwrMedio;lbPwrMedio]';

IntClatONON=[lfPwr2;betaPwr2;hbPwr2;aPwr2;lbPwr2]';
MediaClatONON=[lfPwrMedio2;betaPwrMedio2;hbPwrMedio2;aPwrMedio2;lbPwrMedio2]';

clear StimTemp
clear StimFilt
clear ClatTemp
clear ClatFilt
clear stim2500
clear clat2500
clear ystim
clear yclat
cd ..
cd ..


%----------------------CONDIZIONE ON OFF--------------------------------
%Normalizzazione con passa alto
Bn=fir1(300,600/1250,'high');
An=1;
StimTemp=filter(Bn,An,stim4);
StimFilt=(stim4-mean(StimTemp))./std(StimTemp);
ClatTemp=filter(Bn,An,clat4);
ClatFilt=(clat4-mean(ClatTemp))./std(ClatTemp);


%Filtraggio e sottocampionamento (campionare 125 e nfft 128)
fs=125;
load('LP45Hz_2500.mat');
A=filt1.tf.den;
C=filt1.tf.num;
stim2500=filtfilt(C,A,StimFilt);
clat2500=filtfilt(C,A,ClatFilt);
ystim=stim2500([1:2500/fs:length(stim2500)]);
yclat=clat2500([1:2500/fs:length(clat2500)]);

%Calcolo e visualizzazione spettro
nfft=128;
[Pstim,f] = pwelch(ystim,hanning(nfft),0,nfft,fs);
PSD_ONOFF=abs(Pstim);
[Pclat,f] = pwelch(yclat,hanning(nfft),0,nfft,fs);
PSD_ONOFF2=abs(Pclat);

%Salvataggio spettri
cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
cd('Stim')
save PSD_ONOFF Pstim
cd ..
cd ('Clat')
save PSD_ONOFF_Clat Pclat


%Integrali/medie bande nelle 4 condizioni (da articolo modificazioni
%filter)
flowfreq=[1 7];
fbeta=[8 20];
fhighbeta=[21 40];
falpha=[8 12];
flowbeta=[13 20];

%Low Frequencies
lfMin=find(f>=flowfreq(1)&f<=flowfreq(2));
lfPwr=sum(Pstim(lfMin));
lfPwrMedio=lfPwr/length(lfMin);
lfPwr2=sum(Pclat(lfMin));
lfPwrMedio2=lfPwr2/length(lfMin);

%Beta
betaMin=find(f>=fbeta(1)&f<=fbeta(2));
betaPwr=sum(Pstim(betaMin));
betaPwrMedio=betaPwr/length(betaMin);
betaPwr2=sum(Pclat(betaMin));
betaPwrMedio2=betaPwr2/length(betaMin);

%High-Beta
highbetaMin=find(f>=fhighbeta(1)&f<=fhighbeta(2));
hbPwr=sum(Pstim(highbetaMin));
hbPwrMedio=hbPwr/length(highbetaMin);
hbPwr2=sum(Pclat(highbetaMin));
hbPwrMedio2=hbPwr2/length(highbetaMin);

%Alpha
alphaMin=find(f>=falpha(1)&f<=falpha(2));
aPwr=sum(Pstim(alphaMin));
aPwrMedio=aPwr/length(alphaMin);
aPwr2=sum(Pclat(alphaMin));
aPwrMedio2=aPwr2/length(alphaMin);

%Low-Beta
lowbetaMin=find(f>=flowbeta(1)&f<=flowbeta(2));
lbPwr=sum(Pstim(lowbetaMin));
lbPwrMedio=lbPwr/length(lowbetaMin);
lbPwr2=sum(Pclat(lowbetaMin));
lbPwrMedio2=lbPwr2/length(lowbetaMin);

%Vettori potenze ONOFF
IntStimONOFF=[lfPwr;betaPwr;hbPwr;aPwr;lbPwr]';
MediaStimONOFF=[lfPwrMedio;betaPwrMedio;hbPwrMedio;aPwrMedio;lbPwrMedio]';

IntClatONOFF=[lfPwr2;betaPwr2;hbPwr2;aPwr2;lbPwr2]';
MediaClatONOFF=[lfPwrMedio2;betaPwrMedio2;hbPwrMedio2;aPwrMedio2;lbPwrMedio2]';

clear StimTemp
clear StimFilt
clear ClatTemp
clear ClatFilt
clear stim2500
clear clat2500
clear ystim
clear yclat
cd ..
cd ..

%Vettori totali
IntStim=[IntStimOFFOFF;IntStimOFFON;IntStimONON;IntStimONOFF];
MediaStim=[MediaStimOFFOFF;MediaStimOFFON;MediaStimONON;MediaStimONOFF];

IntClat=[IntClatOFFOFF;IntClatOFFON;IntClatONON;IntClatONOFF];
MediaClat=[MediaClatOFFOFF;MediaClatOFFON;MediaClatONON;MediaClatONOFF];

cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
save IntStim IntStim
save  MediaStim MediaStim
save IntClat IntClat
save MediaClat MediaClat


%--------------------FIGURA SINGOLO PAZ------------------------
f1=figure;
semilogy(f(1:45),abs(PSD_OFFOFF(1:45)),'k','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_OFFON(1:45)),'b','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_ONON(1:45)),'g','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_ONOFF(1:45)),'m','LineWidth',3);
title('PSD Stimulated side');
xlabel('frequency (Hz)'); ylabel('log PSD (AU)');
legend StimOFFMedOFF StimONMedOFF StimONMedON StimOFFMedON

f2=figure;
semilogy(f(1:45),abs(PSD_OFFOFF2(1:45)),'k','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_OFFON2(1:45)),'b','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_ONON2(1:45)),'g','LineWidth',3);
hold on
semilogy(f(1:45),abs(PSD_ONOFF2(1:45)),'m','LineWidth',3);
title('PSD Controalteral side');
xlabel('frequency (Hz)'); ylabel('log PSD (AU)');
legend StimOFFMedOFF StimONMedOFF StimONMedON StimOFFMedON

f3=figure;
plot(MediaStim(:,1),'*m','MarkerSize',15,'LineStyle','-');
hold on
plot(MediaClat(:,1),'*k','MarkerSize',15,'LineStyle','-');
title('Low Frequencies Power');
legend stimulated controlateral

f4=figure;
plot(MediaStim(:,2),'*m','MarkerSize',15,'LineStyle','-');
hold on
plot(MediaClat(:,2),'*k','MarkerSize',15,'LineStyle','-');
title('Beta Power');
legend stimulated controlateral

f5=figure;
plot(MediaStim(:,3),'*m','MarkerSize',15,'LineStyle','-');
hold on
plot(MediaClat(:,3),'*k','MarkerSize',15,'LineStyle','-');
title('HighBeta Power');
legend stimulated controlateral

f6=figure;
plot(MediaStim(:,5),'*m','MarkerSize',15,'LineStyle','-');
hold on
plot(MediaClat(:,5),'*k','MarkerSize',15,'LineStyle','-');
title('LowBeta Power');
legend stimulated controlateral


cd('/Users/saramarceglia/Documents/Didattica/Corsi 2016-2017/Neurosegnali/LFP ANALYSIS');
cd(paz)
saveas(f3,'Low Frequencies','fig');
saveas(f4,'Beta','fig');
saveas(f5,'HighBeta','fig');
saveas(f6,'LowBeta','fig');
cd('Stim')
saveas(f1,strcat('PSD Stim'),'fig'); 
cd ..
cd ('Clat')
saveas(f2,strcat('PSD Clat'),'fig');


%----------------------VARIABILI DI OUTPUT----------------
PSD=[PSD_OFFOFF,PSD_OFFON,PSD_ONON,PSD_ONOFF];
PSD2=[PSD_OFFOFF2,PSD_OFFON2,PSD_ONON2,PSD_ONOFF2]